#ifndef _tpEncodeRTFBullet_tpEncodeRTFBullet_h
#define _tpEncodeRTFBullet_tpEncodeRTFBullet_h

#include <CtrlLib/CtrlLib.h>
#include <RichEdit/RichEdit.h>

using namespace Upp;

#define LAYOUTFILE <tpEncodeRTFBullet/tpEncodeRTFBullet.lay>
#include <CtrlCore/lay.h>


//tp=testPackage
//there are two files in package Sample.rtf/Sample.qtf,
//rtf was converted from qtf - but has that space bug in 2nd bullet
class tpEncodeRTFBullet;
struct REdit:public RichEditWithToolBar{
	ToolBar tb;
	typedef REdit CLASSNAME;
	REdit(){
		InsertFrame(0,tb);
		WhenRefreshBar=[this]{tb.Set(THISBACK(thebar));};
		}
	void LoadFromFile(){
		FileSel fs; fs.ActiveDir(GetExeFolder()); if(!fs.Types("Qtf/rtf files\t*.qtf *.rtf\nAll files\t*.*").ExecuteOpen())return;
		String txt=LoadFile(~fs);
		SetQTF(ToLower(GetFileExt(~fs))==".rtf"?AsQTF(ParseRTF(txt)):txt);
	}
	void SaveAsToFile(){
		FileSel fs; fs.ActiveDir(GetExeFolder()); if(!fs.Types("Qtf/rtf files\t*.qtf *.rtf\nAll files\t*.*").ExecuteSaveAs())return;
		SaveFile(~fs,fs.Get().EndsWith(".rtf")?EncodeRTF(Get()):GetQTF());
	}
	void thebar(Bar& bar){
		bar.Add("open",CtrlImg::open(),[this]{LoadFromFile();});
		bar.Add("saveas...",CtrlImg::save_as(),[this]{SaveAsToFile();});
		bar.Gap(); DefaultBar(bar,true);
	}
};

class tpEncodeRTFBullet : public WithtpEncodeRTFBulletLayout<TopWindow> {
	REdit re;
public:
	typedef tpEncodeRTFBullet CLASSNAME;
	tpEncodeRTFBullet(){
		Sizeable();CtrlLayout(*this,"Window title");
		Add(re.SizePos());
	}
};

#endif
